学习链接:http://www.ihypo.net/1554.html

https://www.slyar.com/blog/depth-first-search-even-odd-pruning.html

http://blog.csdn.net/chyshnu/article/details/6171758

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1010

题解:刚开始写直接超时,还没学剪枝,奇偶剪枝...

关于奇偶剪枝

首先举个例子,有如下4*4的迷宫,'.'为可走路段,'X'为障碍不可通过

S...
....
....
...D

从S到D的最短距离为两点横坐标差的绝对值+两点纵坐标差的绝对值 = abs(Sx - Dx) + abs(Sy - Dy) = 6,这个应该是显而易见的。

遇到有障碍的时候呢

S.XX
X.XX
...X
...D

你会发现不管你怎么绕路,最后从S到达D的距离都是最短距离+一个偶数,这个是可以证明的

而我们知道:

奇数 + 偶数 = 奇数
偶数 + 偶数 = 偶数

因此不管有多少障碍,不管绕多少路,只要能到达目的地,走过的距离必然是跟最短距离的奇偶性是一致的。

所以如果我们知道从S到D的最短距离为奇数,那么当且仅当给定的步数T为奇数时,才有可能走到。如果给定的T的奇偶性与最短距离的奇偶性不一致,那么我们就可以直接判定这条路线永远不可达了。

这里还有个小技巧,我们可以使用按位与运算来简化奇偶性的判断。我们知道1的二进制是1,而奇数的二进制最后一位一定是1,而偶数的二进制最后一位一定是0。所以如果数字&1的结果为1,那么数字为奇数,反之为偶数。

代码:

 #include <stdio.h>
#include <string.h>
#include <math.h>
#include <limits.h>
#include <algorithm>
#include <iostream>
#include <ctype.h>
#include <iomanip>
#include <queue>
#include <stdlib.h>
using namespace std; char map[][];
int flag, Xnum, Sx, Sy, Dx, Dy;
int n, m, t;
int dx[] = {,,,-};
int dy[] = {,-,,}; void DFS(int x, int y, int time)
{
if (x<= || x>n || y<= || y>m) return;
if (flag == ) return;
if (x == Dx && y == Dy && time == t)
{
if(time == t)
flag = ;
return;
} int temp=t-time-abs(x-Dx)-abs(y-Dy);
if(temp<||temp%) return ; for (int i = ; i<; i++)
{
int x1 = x + dx[i];
int y1 = y + dy[i];
if (map[x1][y1] != 'X')
{
map[x1][y1] = 'X';
DFS(x1, y1, time + );
map[x1][y1] = '.';
}
}
return;
} int main()
{
while (cin>>n>>m>>t)
{
if(n==&&m==&&t==) break;
Xnum = ;
for (int i = ; i<=n; i++)
{
for (int j = ; j<=m; j++)
{
cin>>map[i][j];
if (map[i][j] == 'S')
{
Sx = i;
Sy = j;
}
if (map[i][j] == 'D')
{
Dx = i;
Dy = j;
}
if (map[i][j] == 'X')
Xnum ++;
}
}
flag = ;
map[Sx][Sy] = 'X'; if(n*m-Xnum<=t){
cout<<"NO"<<endl;
continue;
}
DFS(Sx, Sy, );
if (flag)
cout<<"YES"<<endl;
else
cout<<"NO"<<endl;
}
return ;
}
04-27 01:45